
package com.example.javacodegeeks.scala.rest

//JSON related libraries
import org.json4s.{DefaultFormats, Formats}

//JSON handling support from Scalatra
import org.scalatra.json._

// JSON library for converting the POJO toString as Json
import org.json4s.native.Json

class Customer(val id:Int, var firstName:String, var lastName:String) {                                   
                                                                                              
        println("Customer - Constructor  BEGIN .... ")

	def this(firstName:String, lastName:String) {
		this(Customer.inc, firstName, lastName)
	}
                                                                                              
        //override def toString = s"Customer [Id=$id, FirstName=$firstName, LastName=$lastName]"

	override def toString = Json(DefaultFormats).write(this) 

	println("Customer - Constructor END .... ")
}                                                                                             
                                                                                              
object Customer {                                                                             
	private var id = 0                                                                    
                                                                                              
        private def inc = {   
	       println(" ****** Inc method called, id = " + id)
       	        id += 1;                                                                      
               	id                                                                            
        }                                                                                     
}                                                                                              
