package com.example.javacodegeeks.scala.rest

import scala.collection._

class CustomerMap {

	println("CustomerMap - Constructor BEGIN... ")

        var map:Map[Int, Customer] = Map()

	init()

	def init() {
		this.add("Raghavan", "Muthu")
	}

        def add(firstName:String, lastName:String):Int = {
		println("CustomerMap - ADD - Invoked")
                var c:Customer = new Customer(firstName, lastName)
		println("New Customer created. Id - " + c.id)
                map += (c.id -> c)
                c.id
        }
	
	def add(c:Customer):Customer = {
		map += (c.id -> c)
		c
	}

        def get(id:Int):Customer = {
                map(id)
        }

        def remove(id:Int) = {
                map = map - id
        }

        def update(id:Int, c:Customer) {
                map += (id -> c)
        }

        override def toString = s"Map :: ${map}"

	println("CustomerMap - Constructor END....")
}

/*object CustomerMap extends App {
	var customerMap = new CustomerMap()

	customerMap.add("Raghavan", "Muthu")
	customerMap.add("Karthick Muthu", "Raghavan")
	customerMap.add("Karthiga Karpagam", "Raghavan")

	println(customerMap)
}*/
